Loading...
Searching...
No Matches
DSRByReferenceTreeNode Class Reference

Class for by-reference relationships. More...

Inheritance diagram for DSRByReferenceTreeNode:

## Public Member Functions

| DSRByReferenceTreeNode (const E_RelationshipType relationshipType)
| constructor
| DSRByReferenceTreeNode (const E_RelationshipType relationshipType, const size_t referencedNodeID, const E_ValueType targetValueType)
| constructor.
| DSRByReferenceTreeNode (const DSRByReferenceTreeNode &node)
| copy constructor.
virtual | ~DSRByReferenceTreeNode ()
| destructor
virtual DSRByReferenceTreeNode * | clone () const
| clone this tree node.
virtual void | clear ()
| clear all member variables.
virtual OFBool | isEqual (const DSRDocumentTreeNode &node) const
| check whether nodes are "equal".
virtual OFBool | isNotEqual (const DSRDocumentTreeNode &node) const
| check whether nodes are "not equal".
virtual OFBool | isValid () const
| check whether the content item is valid.
virtual OFBool | hasValidValue () const
| check whether the value of the content item, i.e. the reference (which has been checked from outside of this class), is valid
virtual OFCondition | print (STD_NAMESPACE ostream &stream, const size_t flags) const
| print content item.
virtual OFCondition | writeXML (STD_NAMESPACE ostream &stream, const size_t flags) const
| write content item in XML format
size_t | getReferencedNodeID () const
| get ID of the referenced node (target content item)
const OFString & | getReferencedContentItem () const
| get position string of the referenced node (target content item)
E_ValueType | getTargetValueType () const
| get value type of the referenced node (target content item)
void | invalidateReference ()
| invalidate reference to the target content item.
OFBool | updateReference (const size_t referencedNodeID, const E_ValueType targetValueType)
| update reference to the target content item (using the node ID).
OFBool | updateReference (const OFString &referencedContentItem)
| update reference the target content item (using the position string).
Public Member Functions inherited from DSRDocumentTreeNode
| DSRDocumentTreeNode (const E_RelationshipType relationshipType, const E_ValueType valueType)
| constructor.
| DSRDocumentTreeNode (const DSRDocumentTreeNode &node)
| copy constructor.
virtual | ~DSRDocumentTreeNode ()
| destructor
virtual OFBool | isShort (const size_t flags) const
| check whether the content is short.
virtual OFBool | hasTemplateIdentification () const
| check whether template identification is set
virtual OFCondition | printExtended (STD_NAMESPACE ostream &stream, const size_t flags) const
| print extended information on the content item.
virtual OFCondition | read (DcmItem &dataset, const DSRIODConstraintChecker *constraintChecker, const size_t flags)
| read content item from dataset.
virtual OFCondition | write (DcmItem &dataset, DcmStack *markedItems=NULL)
| write content item to dataset.
virtual OFCondition | readXML (const DSRXMLDocument &doc, DSRXMLCursor cursor, const E_DocumentType documentType, const size_t flags)
| read general XML document tree node data
virtual OFCondition | renderHTML (STD_NAMESPACE ostream &docStream, STD_NAMESPACE ostream &annexStream, const size_t nestingLevel, size_t &annexNumber, const size_t flags, const char *urlPrefix=NULL) const
| render content item in HTML/XHTML format.
OFBool | isSigned ()
| check whether content item is digitally signed.
OFBool | isMarked () const
| check whether content item is marked.
void | setMark (const OFBool flag)
| mark/unmark the current content item.
OFBool | isReferenceTarget () const
| check whether the current content item is target of a by-reference relationship
void | setReferenceTarget (const OFBool isTarget=OFTrue)
| specify whether the current content item is target of a by-reference relationship
OFBool | hasChildNodes () const
| check whether the current content item has any children
OFBool | hasSiblingNodes () const
| check whether the current content item has any siblings
size_t | getNodeID () const
| get ID of the current tree node
E_RelationshipType | getRelationshipType () const
| get relationship type of the current content item
virtual OFCondition | setRelationshipType (const E_RelationshipType relationshipType)
| set relationship type of the current content item (if previously unknown).
E_ValueType | getValueType () const
| get value type of the current content item
const DSRCodedEntryValue & | getConceptName () const
| get reference to the concept name
virtual OFCondition | getConceptName (DSRCodedEntryValue &conceptName) const
| get copy of the concept name.
const OFString & | getObservationDateTime () const
| get observation date/time.
const OFString & | getObservationUID () const
| get observation unique identifier.
virtual OFBool | compareTemplateIdentification (const OFString &templateIdentifier, const OFString &mappingResource, const OFString &mappingResourceUID="") const
| compare template identification with given values
virtual OFCondition | getTemplateIdentification (OFString &templateIdentifier, OFString &mappingResource) const
| get template identifier and mapping resource.
virtual OFCondition | getTemplateIdentification (OFString &templateIdentifier, OFString &mappingResource, OFString &mappingResourceUID) const
| get template identifier, mapping resource and optional mapping resource UID.
void | removeSignatures ()
| remove digital signatures from content item.
Public Member Functions inherited from DSRTreeNode
| DSRTreeNode (const DSRTreeNodeAnnotation &annotation=DSRTreeNodeAnnotation())
| (default) constructor
virtual | ~DSRTreeNode ()
| destructor
DSRTreeNode * | getPrev () const
| get pointer to previous tree node
DSRTreeNode * | getNext () const
| get pointer to next tree node
DSRTreeNode * | getDown () const
| get pointer to first child node
size_t | getIdent () const
| get unique identifier of this node
OFBool | hasAnnotation () const
| check whether this node has a (non-empty) annotation
void | clearAnnotation ()
| clear annotation of this node
const DSRTreeNodeAnnotation & | getAnnotation () const
| get annotation of this node (optional)
void | setAnnotation (const DSRTreeNodeAnnotation &annotation)
| set annotation of this node (optional)

## Protected Member Functions

virtual OFCondition | readContentItem (DcmItem &dataset, const size_t flags)
| read content item (value) from dataset
virtual OFCondition | writeContentItem (DcmItem &dataset) const
| write content item (value) to dataset
virtual OFCondition | readXMLContentItem (const DSRXMLDocument &doc, DSRXMLCursor cursor, const size_t flags)
| read content item specific XML data
virtual OFCondition | renderHTMLContentItem (STD_NAMESPACE ostream &docStream, STD_NAMESPACE ostream &annexStream, const size_t nestingLevel, size_t &annexNumber, const size_t flags) const
| render content item (value) in HTML/XHTML format
virtual OFCondition | setConceptName (const DSRCodedEntryValue &conceptName, const OFBool check=OFTrue)
| set the concept name
virtual OFCondition | setObservationDateTime (const OFString &observationDateTime, const OFBool check=OFTrue)
| set observation date/time
virtual OFCondition | setObservationDateTime (const DcmElement &delem, const unsigned long pos=0, const OFBool check=OFTrue)
| set observation date/time from element
virtual OFCondition | setObservationDateTime (DcmItem &dataset, const DcmTagKey &tagKey, const unsigned long pos=0, const OFBool check=OFTrue)
| set observation date/time from dataset
virtual OFCondition | setObservationUID (const OFString &observationUID, const OFBool check=OFTrue)
| set observation unique identifier
virtual OFCondition | setTemplateIdentification (const OFString &templateIdentifier, const OFString &mappingResource, const OFString &mappingResourceUID="", const OFBool check=OFTrue)
| set template identifier and mapping resource
virtual OFCondition | renderHTMLContentItem (STD_NAMESPACE ostream &docStream, STD_NAMESPACE ostream &annexStream, const size_t nestingLevel, size_t &annexNumber, const size_t flags, const char *urlPrefix) const
| render content item (value) in HTML/XHTML format.
Protected Member Functions inherited from DSRDocumentTreeNode
DSRCodedEntryValue * | getConceptNamePtr ()
| get pointer to the concept name
DSRDocumentTreeNode * | getPrev () const
| get pointer to previous tree node
DSRDocumentTreeNode * | getNext () const
| get pointer to next tree node
DSRDocumentTreeNode * | getDown () const
| get pointer to first child node
size_t | getIdent () const
| get unique identifier of this node
OFCondition | createAndAppendNewNode (DSRDocumentTreeNode *&previousNode, const E_RelationshipType relationshipType, const E_ValueType valueType, const DSRIODConstraintChecker *constraintChecker=NULL)
| create a new node and append it to the current one
void | writeXMLItemStart (STD_NAMESPACE ostream &stream, const size_t flags, const OFBool closingBracket=OFTrue) const
| write common item start (XML tag)
void | writeXMLItemEnd (STD_NAMESPACE ostream &stream, const size_t flags) const
| write common item start (XML tag)
OFCondition | readSRDocumentContentModule (DcmItem &dataset, const DSRIODConstraintChecker *constraintChecker, const size_t flags)
| read SR document content module
OFCondition | writeSRDocumentContentModule (DcmItem &dataset, DcmStack *markedItems)
| write SR document content module
OFCondition | readDocumentRelationshipMacro (DcmItem &dataset, const DSRIODConstraintChecker *constraintChecker, const OFString &posString, const size_t flags)
| read document relationship macro
OFCondition | writeDocumentRelationshipMacro (DcmItem &dataset, DcmStack *markedItems)
| write document relationship macro
OFCondition | readDocumentContentMacro (DcmItem &dataset, const OFString &posString, const size_t flags)
| read document content macro
OFCondition | writeDocumentContentMacro (DcmItem &dataset) const
| write document content macro
OFCondition | readContentSequence (DcmItem &dataset, const DSRIODConstraintChecker *constraintChecker, const OFString &posString, const size_t flags)
| read content sequence
OFCondition | writeContentSequence (DcmItem &dataset, DcmStack *markedItems) const
| write content sequence
OFCondition | renderHTMLConceptName (STD_NAMESPACE ostream &docStream, const size_t flags) const
| render concept name in HTML/XHTML format.
OFCondition | renderHTMLChildNodes (STD_NAMESPACE ostream &docStream, STD_NAMESPACE ostream &annexStream, const size_t nestingLevel, size_t &annexNumber, const size_t flags, const char *urlPrefix=NULL) const
| render child nodes in HTML/XHTML format
Protected Member Functions inherited from DSRTypes
virtual | ~DSRTypes ()
| destructor.

## Private Attributes

OFBool | ValidReference
| flag indicating whether the reference is valid or not (i.e.
OFString | ReferencedContentItem
| position string of the referenced nodes (target content item).
size_t | ReferencedNodeID
| node ID of the referenced node (target content item).
E_ValueType | TargetValueType
| value type of the referenced node (target content item).

## Additional Inherited Members

Protected Types inherited from DSRTypes

enum

E_DocumentType {
DT_invalid , DT_unknown = DT_invalid , DT_BasicTextSR , DT_EnhancedSR ,
DT_ComprehensiveSR , DT_KeyObjectSelectionDocument , DT_MammographyCadSR , DT_ChestCadSR ,
DT_ColonCadSR , DT_ProcedureLog , DT_XRayRadiationDoseSR , DT_EnhancedXRayRadiationDoseSR ,
DT_SpectaclePrescriptionReport , DT_MacularGridThicknessAndVolumeReport , DT_ImplantationPlanSRDocument , DT_Comprehensive3DSR ,
DT_RadiopharmaceuticalRadiationDoseSR , DT_ExtensibleSR , DT_AcquisitionContextSR , DT_SimplifiedAdultEchoSR ,
DT_PatientRadiationDoseSR , DT_PerformedImagingAgentAdministrationSR , DT_PlannedImagingAgentAdministrationSR , DT_RenditionSelectionDocument ,
DT_WaveformAnnotationSR , DT_last = DT_WaveformAnnotationSR
}

| SR document types (DICOM IOD). More...
enum | E_RelationshipType { RT_invalid , RT_unknown , RT_isRoot , RT_contains , RT_hasObsContext , RT_hasAcqContext , RT_hasConceptMod , RT_hasProperties , RT_inferredFrom , RT_selectedFrom , RT_last = RT_selectedFrom }
| SR relationship types. More...
enum | E_ValueType { VT_invalid , VT_Text , VT_Code , VT_Num , VT_DateTime , VT_Date , VT_Time , VT_UIDRef , VT_PName , VT_SCoord , VT_SCoord3D , VT_TCoord , VT_Composite , VT_Image , VT_Waveform , VT_Container , VT_byReference , VT_includedTemplate , VT_last = VT_includedTemplate }
| SR value types. More...
enum | E_PresentationStateType { PT_invalid , PT_unknown = PT_invalid , PT_Grayscale , PT_Color , PT_PseudoColor , PT_Blending , PT_XAXRFGrayscale , PT_GrayscalePlanarMPR , PT_CompositingPlanarMPR , PT_AdvancedBlending , PT_VolumeRendering , PT_SegmentedVolumeRendering , PT_MultipleVolumeRendering , PT_VariableModalityLUT , PT_Waveform , PT_WaveformAcquisition , PT_last = PT_WaveformAcquisition }
| Softcopy presentation state types. More...
enum | E_GraphicType { GT_invalid , GT_unknown = GT_invalid , GT_Point , GT_Multipoint , GT_Polyline , GT_Circle , GT_Ellipse , GT_last = GT_Ellipse }
| SR graphic types. More...
enum | E_GraphicType3D { GT3_invalid , GT3_unknown = GT3_invalid , GT3_Point , GT3_Multipoint , GT3_Polyline , GT3_Polygon , GT3_Ellipse , GT3_Ellipsoid , GT3_last = GT3_Ellipsoid }
| SR graphic types (3D). More...
enum | E_TemporalRangeType { TRT_invalid , TRT_unknown = TRT_invalid , TRT_Point , TRT_Multipoint , TRT_Segment , TRT_Multisegment , TRT_Begin , TRT_End , TRT_last = TRT_End }
| SR temporal range types. More...
enum | E_ContinuityOfContent { COC_invalid , COC_Separate , COC_Continuous , COC_last = COC_Continuous }
| SR continuity of content flag. More...
enum | E_PreliminaryFlag { PF_invalid , PF_Preliminary , PF_Final , PF_last = PF_Final }
| SR document preliminary flag. More...
enum | E_CompletionFlag { CF_invalid , CF_Partial , CF_Complete , CF_last = CF_Complete }
| SR document completion flag. More...
enum | E_VerificationFlag { VF_invalid , VF_Unverified , VF_Verified , VF_last = VF_Verified }
| SR document verification flag. More...
enum | E_CharacterSet { CS_invalid , CS_unknown = CS_invalid , CS_ASCII , CS_default = CS_ASCII , CS_Latin1 , CS_Latin2 , CS_Latin3 , CS_Latin4 , CS_Cyrillic , CS_Arabic , CS_Greek , CS_Hebrew , CS_Latin5 , CS_Latin9 , CS_Thai , CS_Japanese , CS_Korean , CS_ChineseISO , CS_ChineseGB18030 , CS_ChineseGBK , CS_UTF8 , CS_last = CS_UTF8 }
| Specific character set. More...
enum | E_CodeValueType { CVT_auto , CVT_Short , CVT_Long , CVT_URN }
| Code value type. More...
enum | E_AddMode { AM_afterCurrent , AM_beforeCurrent , AM_belowCurrent , AM_belowCurrentBeforeFirstChild }
| Add node mode. More...
Static Protected Member Functions inherited from DSRDocumentTreeNode
static const OFString & | getRelationshipText (const E_RelationshipType relationshipType, OFString &relationshipText, const size_t flags)
| convert relationship type into a text used for HTML rendering
static OFBool | checkTemplateIdentification (const OFString &templateIdentifier, const OFString &mappingResource, const OFString &mappingResourceUID)
| check the specified template identification values for validity.
Static Protected Member Functions inherited from DSRTreeNode
static size_t | getIdentCounter ()
| get current value of global node counter
Static Protected Member Functions inherited from DSRTypes
static const char * | documentTypeToSOPClassUID (const E_DocumentType documentType)
| convert SR document type to SOP class UID
static const char * | documentTypeToModality (const E_DocumentType documentType)
| convert SR document type to modality
static const char * | documentTypeToReadableName (const E_DocumentType documentType)
| convert SR document type to readable name.
static const char * | documentTypeToDocumentTitle (const E_DocumentType documentType, OFString &documentTitle)
| convert SR document type to document title.
static OFBool | requiresEnhancedEquipmentModule (const E_DocumentType documentType)
| check whether a given SR document type requires the Enhanced General Equipment Module
static OFBool | requiresTimezoneModule (const E_DocumentType documentType)
| check whether a given SR document type requires the Timezone Module
static OFBool | requiresSynchronizationModule (const E_DocumentType documentType)
| check whether a given SR document type requires the Synchronization Module
static OFBool | usesSRDocumentSeriesModule (const E_DocumentType documentType)
| check whether a given SR document type uses the SR Document Series Module (instead of the Key Object Document Series Module)
static OFBool | usesKeyObjectDocumentSeriesModule (const E_DocumentType documentType)
| check whether a given SR document type uses the Key Object Document Series Module (instead of the SR Document Series Module)
static OFBool | usesSRDocumentGeneralModule (const E_DocumentType documentType)
| check whether a given SR document type uses the SR Document General Module (instead of the Key Object Document Module)
static OFBool | usesKeyObjectDocumentModule (const E_DocumentType documentType)
| check whether a given SR document type uses the Key Object Document Module (instead of the SR Document General Module)
static const char * | relationshipTypeToDefinedTerm (const E_RelationshipType relationshipType)
| convert relationship type to DICOM defined term
static const char * | relationshipTypeToReadableName (const E_RelationshipType relationshipType)
| convert relationship type to readable name.
static const char * | valueTypeToDefinedTerm (const E_ValueType valueType)
| convert value type to DICOM defined term
static const char * | valueTypeToXMLTagName (const E_ValueType valueType)
| convert value type to XML tag name
static const char * | valueTypeToReadableName (const E_ValueType valueType)
| convert value type to readable name.
static const char * | presentationStateTypeToShortName (const E_PresentationStateType pstateType)
| convert presentation state type to short name.
static const char * | graphicTypeToEnumeratedValue (const E_GraphicType graphicType)
| convert graphic type to DICOM enumerated value
static const char * | graphicTypeToReadableName (const E_GraphicType graphicType)
| convert graphic type to readable name.
static const char * | graphicType3DToEnumeratedValue (const E_GraphicType3D graphicType)
| convert graphic type (3D) to DICOM enumerated value
static const char * | graphicType3DToReadableName (const E_GraphicType3D graphicType)
| convert graphic type (3D) to readable name.
static const char * | temporalRangeTypeToEnumeratedValue (const E_TemporalRangeType temporalRangeType)
| convert temporal range type to DICOM enumerated value
static const char * | temporalRangeTypeToReadableName (const E_TemporalRangeType temporalRangeType)
| convert temporal range type to readable name.
static const char * | continuityOfContentToEnumeratedValue (const E_ContinuityOfContent continuityOfContent)
| convert continuity of content flag to DICOM enumerated value
static const char * | preliminaryFlagToEnumeratedValue (const E_PreliminaryFlag preliminaryFlag)
| convert preliminary flag to DICOM enumerated value
static const char * | completionFlagToEnumeratedValue (const E_CompletionFlag completionFlag)
| convert completion flag to DICOM enumerated value
static const char * | verificationFlagToEnumeratedValue (const E_VerificationFlag verificationFlag)
| convert verification flag to DICOM enumerated value
static const char * | characterSetToDefinedTerm (const E_CharacterSet characterSet)
| convert character set to DICOM defined term
static const char * | characterSetToHTMLName (const E_CharacterSet characterSet)
| convert character set to HTML name.
static const char * | characterSetToXMLName (const E_CharacterSet characterSet)
| convert character set to XML name.
static E_DocumentType | sopClassUIDToDocumentType (const OFString &sopClassUID)
| convert SOP class UID to SR document type
static E_RelationshipType | definedTermToRelationshipType (const OFString &definedTerm)
| convert DICOM defined term to relationship type
static E_ValueType | definedTermToValueType (const OFString &definedTerm)
| convert DICOM defined term to value type
static E_PresentationStateType | sopClassUIDToPresentationStateType (const OFString &sopClassUID)
| convert SOP class UID to presentation state type
static E_ValueType | xmlTagNameToValueType (const OFString &xmlTagName)
| convert XML tag name to value type
static E_GraphicType | enumeratedValueToGraphicType (const OFString &enumeratedValue)
| convert DICOM enumerated value to graphic type
static E_GraphicType3D | enumeratedValueToGraphicType3D (const OFString &enumeratedValue)
| convert DICOM enumerated value to graphic type (3D)
static E_TemporalRangeType | enumeratedValueToTemporalRangeType (const OFString &enumeratedValue)
| convert DICOM enumerated value to temporal range type
static E_ContinuityOfContent | enumeratedValueToContinuityOfContent (const OFString &enumeratedValue)
| convert DICOM enumerated value to continuity of content flag
static E_PreliminaryFlag | enumeratedValueToPreliminaryFlag (const OFString &enumeratedValue)
| convert DICOM enumerated value to preliminary flag
static E_CompletionFlag | enumeratedValueToCompletionFlag (const OFString &enumeratedValue)
| convert DICOM enumerated value to completion flag
static E_VerificationFlag | enumeratedValueToVerificationFlag (const OFString &enumeratedValue)
| convert DICOM enumerated value to verification flag
static E_CharacterSet | definedTermToCharacterSet (const OFString &definedTerm)
| convert DICOM defined term to character set.
static OFBool | isDocumentTypeSupported (const E_DocumentType documentType)
| check whether specified SR document type is supported by this library
static const OFString & | currentDate (OFString &dateString)
| get current date in DICOM 'DA' format.
static const OFString & | currentTime (OFString &timeString)
| get current time in DICOM 'TM' format.
static const OFString & | currentDateTime (OFString &dateTimeString)
| get current date and time in DICOM 'DT' format.
static const OFString & | localTimezone (OFString &timezoneString)
| get local timezone in DICOM format.
static const OFString & | dicomToReadableDate (const OFString &dicomDate, OFString &readableDate)
| convert DICOM date string to readable format.
static const OFString & | dicomToReadableTime (const OFString &dicomTime, OFString &readableTime)
| convert DICOM time string to readable format.
static const OFString & | dicomToReadableDateTime (const OFString &dicomDateTime, OFString &readableDateTime)
| convert DICOM date time string to readable format.
static const OFString & | dicomToReadablePersonName (const OFString &dicomPersonName, OFString &readablePersonName)
| convert DICOM person name to readable format.
static const OFString & | dicomToXMLPersonName (const OFString &dicomPersonName, OFString &xmlPersonName, const OFBool writeEmptyValue=OFFalse)
| convert DICOM person name to XML format.
static const char * | numberToString (const size_t number, char *stringValue, size_t stringLength)
| convert unsigned integer number to character string
static size_t | stringToNumber (const char *stringValue)
| convert string to unsigned integer number
static const OFString & | convertToPrintString (const OFString &sourceString, OFString &printString)
| convert character string to print string.
static const OFString & | convertToHTMLString (const OFString &sourceString, OFString &markupString, const size_t flags=0, const OFBool newlineAllowed=OFFalse)
| convert character string to HTML mnenonic string.
static const OFString & | convertToXMLString (const OFString &sourceString, OFString &markupString)
| convert character string to XML mnenonic string.
static OFBool | checkForValidReference (const OFString &stringValue)
| check string for valid reference (as used for by-reference relationships).
static DSRIODConstraintChecker * | createIODConstraintChecker (const E_DocumentType documentType)
| create specified SR IOD content relationship constraint checker object.
static DSRDocumentTreeNode * | createDocumentTreeNode (const E_RelationshipType relationshipType, const E_ValueType valueType)
| create specified document tree node.
static OFCondition | addElementToDataset (OFCondition &result, DcmItem &dataset, DcmElement *delem, const OFString &vm, const OFString &type, const char *moduleName=NULL)
| add given element to the dataset.
static void | removeAttributeFromSequence (DcmSequenceOfItems &sequence, const DcmTagKey &tagKey)
| remove given attribute from the sequence.
static OFCondition | getElementFromDataset (DcmItem &dataset, DcmElement &delem)
| get element from dataset
static const char * | getStringValueFromElement (const DcmElement &delem)
| get string value from element
static const OFString & | getStringValueFromElement (const DcmElement &delem, OFString &stringValue)
| get string value from element.
static OFCondition | getStringValueFromElement (const DcmElement &delem, OFString &stringValue, const signed long pos)
| get string value from element
static const OFString & | getPrintStringFromElement (const DcmElement &delem, OFString &stringValue)
| get string value from element and convert to "print" format.
static const OFString & | getMarkupStringFromElement (const DcmElement &delem, OFString &stringValue, const OFBool convertNonASCII=OFFalse)
| get string value from element and convert to HTML/XML.
static OFCondition | getStringValueFromDataset (DcmItem &dataset, const DcmTagKey &tagKey, OFString &stringValue, const signed long pos=0)
| get string value from dataset
static OFCondition | putStringValueToDataset (DcmItem &dataset, const DcmTag &tag, const OFString &stringValue, const OFBool allowEmpty=OFTrue)
| put string value to dataset
static OFBool | checkElementValue (DcmElement *delem, const DcmTagKey &tagKey, const OFString &vm, const OFString &type, const OFCondition &searchCond=EC_Normal, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| check element value for correct value multiplicity and type.
static OFBool | checkElementValue (DcmElement &delem, const OFString &vm, const OFString &type, const OFCondition &searchCond=EC_Normal, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| check element value for correct value multiplicity and type.
static OFCondition | getAndCheckElementFromDataset (DcmItem &dataset, DcmElement &delem, const OFString &vm, const OFString &type, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| get element from dataset and check it for correct value multiplicity and type.
static OFCondition | getAndCheckStringValueFromDataset (DcmItem &dataset, const DcmTagKey &tagKey, OFString &stringValue, const OFString &vm, const OFString &type, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| get string value from dataset and check it for correct value multiplicity and type.
static void | printInvalidContentItemMessage (const char *action, const DSRDocumentTreeNode *node, const char *location=NULL)
| print the warning message that the current content item is invalid/incomplete.
static void | printContentItemErrorMessage (const char *action, const OFCondition &result, const DSRDocumentTreeNode *node, const char *location=NULL)
| print an error message for the current content item.
static void | printUnknownValueWarningMessage (const char *valueName, const char *readValue=NULL, const char *action="Reading")
| print a warning message that an unknown/unsupported value has been determined
static OFBool | writeStringValueToXML (STD_NAMESPACE ostream &stream, const OFString &stringValue, const OFString &tagName, const OFBool writeEmptyValue=OFFalse)
| write string value to XML output stream.
static OFBool | writeStringFromElementToXML (STD_NAMESPACE ostream &stream, DcmElement &delem, const OFString &tagName, const OFBool writeEmptyValue=OFFalse)
| write string value from DICOM element to XML output stream.
static size_t | createHTMLAnnexEntry (STD_NAMESPACE ostream &docStream, STD_NAMESPACE ostream &annexStream, const OFString &referenceText, size_t &annexNumber, const size_t flags=0)
| create an HTML annex entry with hyperlinks.
static size_t | createHTMLFootnote (STD_NAMESPACE ostream &docStream, STD_NAMESPACE ostream &footnoteStream, size_t &footnoteNumber, const size_t nodeID, const size_t flags=0)
| create an HTML footnote with hyperlinks
static OFCondition | appendStream (STD_NAMESPACE ostream &mainStream, OFOStringStream &tempStream, const char *heading=NULL)
| append one output stream to another.
Protected Attributes inherited from DSRTreeNode
DSRTreeNode * | Prev
| pointer to previous tree node (if any)
DSRTreeNode * | Next
| pointer to next tree node (if any)
DSRTreeNode * | Down
| pointer to first child node (if any)
DSRTreeNodeAnnotation | Annotation
| annotation of the tree node (optional)
Static Protected Attributes inherited from DSRTypes
static const size_t | RF_readDigitalSignatures
| read digital signatures from dataset
static const size_t | RF_acceptUnknownRelationshipType
| accept unknown/missing relationship type
static const size_t | RF_acceptInvalidContentItemValue
| accept invalid content item value (e.g. violation of VR or VM definition)
static const size_t | RF_ignoreRelationshipConstraints
| ignore relationship constraints for this document class
static const size_t | RF_ignoreContentItemErrors
| do not abort on content item errors (e.g. missing value type specific attributes)
static const size_t | RF_skipInvalidContentItems
| do not abort when detecting an invalid content item, skip invalid sub-tree instead
static const size_t | RF_showCurrentlyProcessedItem
| show the currently processed content item (e.g. "1.2.3")
static const size_t | HF_neverExpandChildrenInline
| external: never expand child nodes inline
static const size_t | HF_alwaysExpandChildrenInline
| external: always expand child nodes inline
static const size_t | HF_renderInlineCodes
| external: render codes even if they appear inline
static const size_t | HF_useCodeDetailsTooltip
| external: render code details as a tooltip (not with HTML 3.2)
static const size_t | HF_renderConceptNameCodes
| external: render concept name codes (default: code meaning only)
static const size_t | HF_renderNumericUnitCodes
| external: render the code of the numeric measurement unit
static const size_t | HF_useCodeMeaningAsUnit
| external: use code meaning for the numeric measurement unit (default: code value)
static const size_t | HF_renderPatientTitle
| external: use patient information as document title (default: document type)
static const size_t | HF_renderNoDocumentHeader
| external: render no general document information (header)
static const size_t | HF_renderDcmtkFootnote
| external: render dcmtk/dcmsr comment at the end of the document
static const size_t | HF_renderFullData
| external: render the full data of all content items
static const size_t | HF_renderSectionTitlesInline
| external: render section titles inline (default: separate paragraph)
static const size_t | HF_copyStyleSheetContent
| external: copy Cascading Style Sheet (CSS) content to HTML file
static const size_t | HF_HTML32Compatibility
| external: output compatible to HTML version 3.2 (default: 4.01)
static const size_t | HF_XHTML11Compatibility
| external: output compatible to XHTML version 1.1 (default: HTML 4.01)
static const size_t | HF_addDocumentTypeReference
| external: add explicit reference to HTML document type (DTD)
static const size_t | HF_omitGeneratorMetaElement
| external: omit generator meta element referring to the DCMTK
static const size_t | HF_renderItemsSeparately
| internal: render items separately (for container with SEPARATE flag)
static const size_t | HF_renderItemInline
| internal: expand items inline when they are short and have no child nodes
static const size_t | HF_currentlyInsideAnnex
| internal: content item is rendered fully inside the annex
static const size_t | HF_createFootnoteReferences
| internal: create footnote references
static const size_t | HF_convertNonASCIICharacters
| internal: convert non-ASCII characters (> #127) to &#nnn;
static const size_t | HF_renderAllCodes
| shortcut: render all codes
static const size_t | HF_internalUseOnly
| shortcut: filter all flags that are only used internally
static const size_t | XF_writeEmptyTags
| write: write all tags even if their value is empty
static const size_t | XF_writeTemplateIdentification
| write: write template identification information (TID and mapping resource)
static const size_t | XF_alwaysWriteItemIdentifier
| write: always write item identifier "id", not only when item is referenced
static const size_t | XF_codeComponentsAsAttribute
| write: encode code value, coding scheme designator and coding scheme version as attribute instead of element text
static const size_t | XF_relationshipTypeAsAttribute
| write: encode relationship type as attribute instead of element text
static const size_t | XF_valueTypeAsAttribute
| write: encode value type as attribute instead of element text
static const size_t | XF_templateIdentifierAsAttribute
| write: encode template identifier as attribute instead of element text
static const size_t | XF_useDcmsrNamespace
| write: add DCMSR namespace declaration to the XML output
static const size_t | XF_addSchemaReference
| write: add Schema reference to XML document
static const size_t | XF_validateSchema
| read: validate content of XML document against Schema
static const size_t | XF_templateElementEnclosesItems
| read/write: template identification element encloses content items
static const size_t | XF_addCommentsForIncludedTemplate
| write: add comments with details at beginning/end of included template (might be useful for debugging purposes)
static const size_t | XF_acceptEmptyStudySeriesInstanceUID
| read: accept empty Study/Series/SOP Instance UID attribute values (must be filled later)
static const size_t | XF_encodeEverythingAsAttribute
| shortcut: combines all XF_xxxAsAttribute write flags (see above)
static const size_t | PF_printItemPosition
| print item position ("1.2.3") instead of line indentation
static const size_t | PF_shortenLongItemValues
| shorten long item value (e.g. long texts)
static const size_t | PF_printSOPInstanceUID
| print SOP instance UID of referenced objects
static const size_t | PF_printConceptNameCodes
| print coding scheme designator/version and code value of concept names
static const size_t | PF_printNoDocumentHeader
| print no general document information (header)
static const size_t | PF_printTemplateIdentification
| print template identification (TID and mapping resource)
static const size_t | PF_useANSIEscapeCodes
| use ANSI escape codes for output
static const size_t | PF_printLongSOPClassName
| print long SOP class name of referenced objects (default: short name for images)
static const size_t | PF_printSOPClassUID
| print SOP class UID of referenced objects (instead of the name)
static const size_t | PF_printInvalidCodes
| print code triple for invalid codes (instead of the text "invalid code")
static const size_t | PF_printNodeID
| print node ID at the beginning of each line (might be useful for debugging purposes)
static const size_t | PF_indicateEnhancedEncodingMode
| indicate with a "*" that the "enhanced encoding mode" is used for codes
static const size_t | PF_printAnnotation
| print annotation of a content item (optional, e.g. user-defined information)
static const size_t | PF_hideIncludedTemplateNodes
| do not print internal "included template" nodes (position counter is still increased)
static const size_t | PF_dontCountIncludedTemplateNodes
| do not count internal "included template" nodes (only with PF_hideIncludedTemplateNodes)
static const size_t | PF_printEmptyCodes
| print text "empty code" for empty codes (instead of "invalid code")
static const size_t | PF_printAllCodes
| shortcut: print all codes (combines all PF_printXxxCodes flags, see above)
static const size_t | CM_updatePositionString
| update the position string using the node ID
static const size_t | CM_updateNodeID
| update the node ID using the position string
static const size_t | CM_resetReferenceTargetFlag
| reset the reference target flag for all nodes
static const size_t | CB_maskPrintFlags
| bit mask (filter) for valid print flags (see PF_xxx)
static const size_t | CB_maskReadFlags
| bit mask (filter) for valid read flags (see RF_xxx)

## Detailed Description

Class for by-reference relationships.

## Constructor & Destructor Documentation

## DSRByReferenceTreeNode() [1/3]

DSRByReferenceTreeNode::DSRByReferenceTreeNode | ( | const E_RelationshipType | relationshipType | ) |

constructor

Parameters

  relationshipType | type of relationship to the parent/source tree node. Should not be DSRTypes::RT_invalid or DSRTypes::RT_isRoot.

Referenced by DSRByReferenceTreeNode(), and clone().

## DSRByReferenceTreeNode() [2/3]

DSRByReferenceTreeNode::DSRByReferenceTreeNode | ( | const E_RelationshipType | relationshipType,
|  | const size_t | referencedNodeID,
|  | const E_ValueType | targetValueType )

constructor.

The passed values are stored but the reference stays invalid until updated by updateReference().

Parameters

  relationshipType | type of relationship to the parent/source tree node. Should not be DSRTypes::RT_invalid or DSRTypes::RT_isRoot.
  referencedNodeID | ID of the node to be referenced (target content item)
  targetValueType | value type of the node to be referenced, i.e. the target

## DSRByReferenceTreeNode() [3/3]

DSRByReferenceTreeNode::DSRByReferenceTreeNode | ( | const DSRByReferenceTreeNode & | node | ) |

copy constructor.

Please note that the comments on the copy constructor of the base class DSRDocumentTreeNode apply. Furthermore, the following member variables of this class are also not copied but initialized with their default values:

- ValidReference
- ReferencedNodeID
- TargetValueType

As a result, the contained by-reference relationship becomes invalid and should be updated by updateReference() after the node has been added to a document tree.

Parameters

  node | tree node to be copied

References DSRByReferenceTreeNode().

## Member Function Documentation

## clear()

virtual void DSRByReferenceTreeNode::clear | ( |  | ) |

virtual

clear all member variables.

Please note that the content item becomes invalid afterwards.

Reimplemented from DSRDocumentTreeNode.

## clone()

virtual DSRByReferenceTreeNode * DSRByReferenceTreeNode::clone | ( |  | ) | const

virtual

clone this tree node.

Internally, the copy constructor is used, so the corresponding comments apply.

Returns
  copy of this tree node

Implements DSRDocumentTreeNode.

References DSRByReferenceTreeNode().

## getReferencedContentItem()

const OFString & DSRByReferenceTreeNode::getReferencedContentItem | ( |  | ) | const

inline

get position string of the referenced node (target content item)

Returns
  position string of the referenced node if valid, an empty string otherwise

References ReferencedContentItem.

## getReferencedNodeID()

size_t DSRByReferenceTreeNode::getReferencedNodeID | ( |  | ) | const

inline

get ID of the referenced node (target content item)

Returns
  ID of the referenced node if valid, 0 otherwise

References ReferencedNodeID.

## getTargetValueType()

E_ValueType DSRByReferenceTreeNode::getTargetValueType | ( |  | ) | const

inline

get value type of the referenced node (target content item)

Returns
  value type of the referenced node if valid, DSRTypes::VT_invalid otherwise

References TargetValueType.

## hasValidValue()

virtual OFBool DSRByReferenceTreeNode::hasValidValue | ( |  | ) | const

virtual

check whether the value of the content item, i.e. the reference (which has been checked from outside of this class), is valid

Returns
  OFTrue if the value is valid, OFFalse otherwise

Reimplemented from DSRDocumentTreeNode.

## invalidateReference()

void DSRByReferenceTreeNode::invalidateReference | ( |  | ) |

invalidate reference to the target content item.

Sets the internal flag accordingly, see isValid() method.

## isEqual()

virtual OFBool DSRByReferenceTreeNode::isEqual | ( | const DSRDocumentTreeNode & | node | ) | const

virtual

check whether nodes are "equal".

Two tree nodes are equal if the comparison operator of the base class DSRDocumentTreeNode regards them as "equal" (same types and concept names) and the stored values are equal. In this case, the IDs of the referenced nodes are used (if the references are valid).

Parameters

  node | tree node that should be compared to the current one

Returns
  OFTrue if both tree nodes are equal, OFFalse otherwise

Reimplemented from DSRDocumentTreeNode.

References DSRDocumentTreeNode::DSRDocumentTreeNode().

## isNotEqual()

virtual OFBool DSRByReferenceTreeNode::isNotEqual | ( | const DSRDocumentTreeNode & | node | ) | const

virtual

check whether nodes are "not equal".

Two tree nodes are not equal if either the comparison operator of the base class DSRDocumentTreeNode regards them as "not equal" (different types or concept names) or the stored values are not equal. In this case, the IDs of the referenced nodes are used (if the references are valid).

Parameters

  node | tree node that should be compared to the current one

Returns
  OFTrue if both tree nodes are not equal, OFFalse otherwise

Reimplemented from DSRDocumentTreeNode.

References DSRDocumentTreeNode::DSRDocumentTreeNode().

## isValid()

virtual OFBool DSRByReferenceTreeNode::isValid | ( |  | ) | const

virtual

check whether the content item is valid.

The content item is valid if the base class is valid, the concept name is empty and the reference (see hasValidValue()) is valid.

Returns
  OFTrue if tree node is valid, OFFalse otherwise

Reimplemented from DSRDocumentTreeNode.

## print()

virtual OFCondition DSRByReferenceTreeNode::print | ( | STD_NAMESPACE ostream & | stream,
|  | const size_t | flags ) const

virtual

print content item.

A typical output looks like this: inferred from 1.2.3. If the position string of the referenced target content item is empty, a "?" (question mark) is printed.

Parameters

  stream | output stream to which the content item should be printed
  flags | flag used to customize the output (see DSRTypes::PF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRDocumentTreeNode.

## readContentItem()

virtual OFCondition DSRByReferenceTreeNode::readContentItem | ( | DcmItem & | dataset,
|  | const size_t | flags )

protected virtual

read content item (value) from dataset

Parameters

  dataset | DICOM dataset from which the content item should be read
  flags | flag used to customize the reading process (see DSRTypes::RF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRDocumentTreeNode.

## readXMLContentItem()

virtual OFCondition DSRByReferenceTreeNode::readXMLContentItem | ( | const DSRXMLDocument & | doc,
|  | DSRXMLCursor | cursor,
|  | const size_t | flags )

protected virtual

read content item specific XML data

Parameters

  doc | document containing the XML file content
  cursor | cursor pointing to the starting node
  flags | flag used to customize the reading process (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRDocumentTreeNode.

## renderHTMLContentItem() [1/2]

virtual OFCondition DSRByReferenceTreeNode::renderHTMLContentItem | ( | STD_NAMESPACE ostream & | docStream,
|  | STD_NAMESPACE ostream & | annexStream,
|  | const size_t | nestingLevel,
|  | size_t & | annexNumber,
|  | const size_t | flags ) const

protected virtual

render content item (value) in HTML/XHTML format

Parameters

  docStream | output stream to which the main HTML/XHTML document is written
  annexStream | output stream to which the HTML/XHTML document annex is written
  nestingLevel | current nesting level. Used to render section headings.
  annexNumber | reference to the variable where the current annex number is stored. Value is increased automatically by 1 after a new entry has been added.
  flags | flag used to customize the output (see DSRTypes::HF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRDocumentTreeNode.

## renderHTMLContentItem() [2/2]

virtual OFCondition DSRDocumentTreeNode::renderHTMLContentItem | ( | STD_NAMESPACE ostream & | docStream,
|  | STD_NAMESPACE ostream & | annexStream,
|  | const size_t | nestingLevel,
|  | size_t & | annexNumber,
|  | const size_t | flags,
|  | const char * | urlPrefix ) const

protected virtual

render content item (value) in HTML/XHTML format.

This method calls the previous method (without 'urlPrefix'). Derived classes overwrite it to render the contents according to their value type.

Parameters

  docStream | output stream to which the main HTML/XHTML document is written
  annexStream | output stream to which the HTML/XHTML document annex is written
  nestingLevel | current nesting level. Used to render section headings.
  annexNumber | reference to the variable where the current annex number is stored. Value is increased automatically by 1 after a new entry has been added.
  flags | flag used to customize the output (see DSRTypes::HF_xxx)
  urlPrefix | URL prefix used for hyperlink to referenced composite object

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRDocumentTreeNode.

## setConceptName()

virtual OFCondition DSRByReferenceTreeNode::setConceptName | ( | const DSRCodedEntryValue & | conceptName,
|  | const OFBool | check = OFTrue )

protected virtual

set the concept name

Parameters

  conceptName | dummy parameter
  check | dummy parameter

Returns
  always returns EC_IllegalCall, since this content item has no concept name

Reimplemented from DSRDocumentTreeNode.

## setObservationDateTime() [1/3]

virtual OFCondition DSRByReferenceTreeNode::setObservationDateTime | ( | const DcmElement & | delem,
|  | const unsigned long | pos = 0,
|  | const OFBool | check = OFTrue )

protected virtual

set observation date/time from element

Parameters

  delem | dummy parameter
  pos | dummy parameter
  check | dummy parameter

Returns
  always returns EC_IllegalCall, since this content item has no observation date and time (part of Document Relationship Macro)

Reimplemented from DSRDocumentTreeNode.

## setObservationDateTime() [2/3]

virtual OFCondition DSRByReferenceTreeNode::setObservationDateTime | ( | const OFString & | observationDateTime,
|  | const OFBool | check = OFTrue )

protected virtual

set observation date/time

Parameters

  observationDateTime | dummy parameter
  check | dummy parameter

Returns
  always returns EC_IllegalCall, since this content item has no observation date and time (part of Document Relationship Macro)

Reimplemented from DSRDocumentTreeNode.

## setObservationDateTime() [3/3]

virtual OFCondition DSRByReferenceTreeNode::setObservationDateTime | ( | DcmItem & | dataset,
|  | const DcmTagKey & | tagKey,
|  | const unsigned long | pos = 0,
|  | const OFBool | check = OFTrue )

protected virtual

set observation date/time from dataset

Parameters

  dataset | dummy parameter
  tagKey | dummy parameter
  pos | dummy parameter
  check | dummy parameter

Returns
  always returns EC_IllegalCall, since this content item has no observation date and time (part of Document Relationship Macro)

Reimplemented from DSRDocumentTreeNode.

## setObservationUID()

virtual OFCondition DSRByReferenceTreeNode::setObservationUID | ( | const OFString & | observationUID,
|  | const OFBool | check = OFTrue )

protected virtual

set observation unique identifier

Parameters

  observationUID | dummy parameter
  check | dummy parameter

Returns
  always returns EC_IllegalCall, since this content item has no observation unique identifier (part of Document Relationship Macro)

Reimplemented from DSRDocumentTreeNode.

## setTemplateIdentification()

virtual OFCondition DSRByReferenceTreeNode::setTemplateIdentification | ( | const OFString & | templateIdentifier,
|  | const OFString & | mappingResource,
|  | const OFString & | mappingResourceUID = "",
|  | const OFBool | check = OFTrue )

protected virtual

set template identifier and mapping resource

Parameters

  templateIdentifier | dummy parameter
  mappingResource | dummy parameter
  mappingResourceUID | dummy parameter
  check | dummy parameter

Returns
  always returns EC_IllegalCall, since this content item has no template identification (part of Document Relationship Macro)

Reimplemented from DSRDocumentTreeNode.

References DSRDocumentTreeNode::renderHTMLContentItem().

## updateReference() [1/2]

OFBool DSRByReferenceTreeNode::updateReference | ( | const OFString & | referencedContentItem | ) |

update reference the target content item (using the position string).

Also sets the internal flag accordingly, see isValid() method. Please note, however, that it is not checked whether the referenced content item really exists. This is done later on by DSRDocumentSubTree::checkByReferenceRelationships().

Parameters

  referencedContentItem | position string of the node to be referenced

Returns
  OFTrue if the reference is valid, OFFalse otherwise

## updateReference() [2/2]

OFBool DSRByReferenceTreeNode::updateReference | ( | const size_t | referencedNodeID,
|  | const E_ValueType | targetValueType )

update reference to the target content item (using the node ID).

Also sets the internal flag accordingly, see isValid() method. Please note, however, that it is not checked whether the referenced content item really exists. This is done later on by DSRDocumentSubTree::checkByReferenceRelationships().

Parameters

  referencedNodeID | ID of the node to be referenced (target content item)
  targetValueType | value type of the node to be referenced, i.e. the target

Returns
  OFTrue if the reference is valid, OFFalse otherwise

## writeContentItem()

virtual OFCondition DSRByReferenceTreeNode::writeContentItem | ( | DcmItem & | dataset | ) | const

protected virtual

write content item (value) to dataset

Parameters

  dataset | DICOM dataset to which the content item should be written

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRDocumentTreeNode.

## writeXML()

virtual OFCondition DSRByReferenceTreeNode::writeXML | ( | STD_NAMESPACE ostream & | stream,
|  | const size_t | flags ) const

virtual

write content item in XML format

Parameters

  stream | output stream to which the XML document is written
  flags | flag used to customize the output (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRDocumentTreeNode.

## Member Data Documentation

## ReferencedContentItem

OFString DSRByReferenceTreeNode::ReferencedContentItem

private

position string of the referenced nodes (target content item).

The default value is en empty string.

Referenced by getReferencedContentItem().

## ReferencedNodeID

size_t DSRByReferenceTreeNode::ReferencedNodeID

private

node ID of the referenced node (target content item).

The default value is 0.

Referenced by getReferencedNodeID().

## TargetValueType

E_ValueType DSRByReferenceTreeNode::TargetValueType

private

value type of the referenced node (target content item).

The default value is DSRTypes::VT_invalid.

Referenced by getTargetValueType().

## ValidReference

OFBool DSRByReferenceTreeNode::ValidReference

private

flag indicating whether the reference is valid or not (i.e.

checked). The default value is OFFalse.

The documentation for this class was generated from the following file:

- dcmsr/include/dcmtk/dcmsr/dsrreftn.h

Generated on for DCMTK Version 3.7.0 by Doxygen 1.15.0